Bug 1016294 - Review Request: kryo-serializers - Additional kryo for standard JDK types
Summary: Review Request: kryo-serializers - Additional kryo for standard JDK types
Keywords:
Status: CLOSED RAWHIDE
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: gil cattaneo
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: bigdata-review
TreeView+ depends on / blocked
 
Reported: 2013-10-07 19:51 UTC by Timothy St. Clair
Modified: 2013-11-14 21:21 UTC (History)
5 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2013-11-14 21:21:49 UTC
Type: ---
puntogil: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)
review notes (7.65 KB, text/plain)
2013-10-07 20:49 UTC, gil cattaneo
no flags Details
review notes (7.67 KB, text/plain)
2013-10-08 20:49 UTC, gil cattaneo
no flags Details
review notes (7.68 KB, text/plain)
2013-10-09 21:53 UTC, gil cattaneo
no flags Details

Description Timothy St. Clair 2013-10-07 19:51:45 UTC
Spec URL: http://tstclair.fedorapeople.org/tachyon/kryo-serializers/kryo-serializers.spec

SRPM URL: http://tstclair.fedorapeople.org/tachyon/kryo-serializers/kryo-serializers-0.23-2.fc21.src.rpm

Description: Additional kryo (http://kryo.googlecode.com) serializers for
standard JDK types (e.g. currency, JDK proxies) and
some for external libraries (e.g. JODA TIME, CGLIB proxies).

Fedora Account System Username: tstclair

Comment 1 Timothy St. Clair 2013-10-07 19:58:55 UTC
Here are my notes, please comment if you find an issue. 

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "Apache (v2.0)", "Unknown or generated". 5 files have unknown license.
     Detailed output of licensecheck in /home/tstclair/work/spaces/tachyon
     /kryo-serializers-rpm/review-kryo-serializers/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[-]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[?]: Package does not generate any conflict.
[-]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[ ]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[-]: Package is not known to require an ExcludeArch tag.
[ ]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 30720 bytes in 2 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: No rpmlint messages.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Java:
[x]: Packages have proper BuildRequires/Requires on jpackage-utils
     Note: Maven packages do not need to (Build)Require jpackage-utils. It is
     pulled in by maven-local
[x]: Javadoc documentation files are generated and included in -javadoc
     subpackage
[x]: Javadoc subpackages should not have Requires: jpackage-utils
[x]: Javadocs are placed in %{_javadocdir}/%{name} (no -%{version} symlink)
[x]: Bundled jar/class files should be removed before build

Maven:
[ ]: If package contains pom.xml files install it (including depmaps) even
     when building with ant
[x]: Pom files have correct Maven mapping
[x]: Maven packages should use new style packaging
[x]: Old add_to_maven_depmap macro is not being used
[x]: Packages DOES NOT have Requires(post) and Requires(postun) on jpackage-
     utils for %update_maven_depmap macro
[x]: Package DOES NOT use %update_maven_depmap in %post/%postun
[x]: Packages use %{_mavenpomdir} instead of %{_datadir}/maven2/poms

===== SHOULD items =====

Generic:
[ ]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[ ]: Final provides and requires are sane (see attachments).
[ ]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in kryo-
     serializers-javadoc
[ ]: Package functions as described.
[ ]: Latest version is packaged.
[ ]: Package does not include license text files separate from upstream.
[ ]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[ ]: Package should compile and build into binary rpms on all supported
     architectures.
[ ]: %check is present and all tests pass.
[ ]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX tarball generation or download is documented.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

Java:
[ ]: Package uses upstream build method (ant/maven/etc.)
[x]: Packages are noarch unless they use JNI

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: No rpmlint messages.
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: kryo-serializers-0.23-2.fc21.noarch.rpm
          kryo-serializers-javadoc-0.23-2.fc21.noarch.rpm
          kryo-serializers-0.23-2.fc21.src.rpm
3 packages and 0 specfiles checked; 0 errors, 0 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint kryo-serializers-javadoc kryo-serializers
2 packages and 0 specfiles checked; 0 errors, 0 warnings.
# echo 'rpmlint-done:'



Requires
--------
kryo-serializers-javadoc (rpmlib, GLIBC filtered):
    jpackage-utils

kryo-serializers (rpmlib, GLIBC filtered):
    jpackage-utils
    mvn(cglib:cglib)
    mvn(com.esotericsoftware.kryo:kryo)
    mvn(joda-time:joda-time)



Provides
--------
kryo-serializers-javadoc:
    kryo-serializers-javadoc

kryo-serializers:
    kryo-serializers
    mvn(de.javakaffee:kryo-serializers)
    osgi(de.javakaffee.kryo-serializers)



Source checksums
----------------
https://github.com/magro/kryo-serializers/archive/kryo-serializers-0.23.tar.gz :
  CHECKSUM(SHA256) this package     : 290cd93d93e3f47634c9ece9069ef927d57244e714d351fd374ae3053df9dc9c
  CHECKSUM(SHA256) upstream package : 290cd93d93e3f47634c9ece9069ef927d57244e714d351fd374ae3053df9dc9c


Generated by fedora-review 0.5.0 (920221d) last change: 2013-08-30
Command line :/usr/bin/fedora-review -m fedora-rawhide-x86_64 -n kryo-serializers
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api, Java
Disabled plugins: C/C++, Python, SugarActivity, Perl, R, PHP, Ruby
Disabled flags: EPEL5, EXARCH, DISTTAG

Comment 2 gil cattaneo 2013-10-07 20:17:04 UTC
i would like to take this review

Comment 3 gil cattaneo 2013-10-07 20:49:26 UTC
Created attachment 809018 [details]
review notes

This is a problem:
src/test/java/de/javakaffee/kryoserializers/cglib/CustomClassLoader.java
[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "Apache (v2.0)", "Unknown or generated". 5 files have unknown license.
     Detailed output of licensecheck in /home/gil/1016294-kryo-
     serializers/licensecheck.txt

[!]: Sources contain only permissible code or content.

reports this
 * $Id$
 * (c) Copyright 2009 freiheit.com technologies GmbH
 *
 * Created on Jun 25, 2010 by Martin Grotzke (martin.grotzke@freiheit.com)
 *
 * This file contains unpublished, proprietary trade secret information of
 * freiheit.com technologies GmbH. Use, transcription, duplication and
 * modification are strictly prohibited without prior written consent of
 * freiheit.com technologies GmbH.

please, remove form taraball, also before import in SCM

Comment 4 Timothy St. Clair 2013-10-07 21:31:21 UTC
Issue files upstream and tracking: https://github.com/magro/kryo-serializers/issues/16

Comment 5 Timothy St. Clair 2013-10-07 21:31:41 UTC
Issue filed upstream and tracking: https://github.com/magro/kryo-serializers/issues/16

Comment 7 gil cattaneo 2013-10-08 17:21:40 UTC
Issues:
=======
- Sources used to build the package match the upstream source, as provided in
  the spec URL.
  Note: Upstream MD5sum check error, diff is in /home/gil/1016294-kryo-
  serializers/diff.txt
  See: http://fedoraproject.org/wiki/Packaging/SourceURL
please, (rename source archive e.g. kryo-serializers-0.23-clean.tar.xz)
and/or dont use source url (https://github.com/magro/kryo-serializers/archive/)

Comment 8 gil cattaneo 2013-10-08 18:15:40 UTC
e.g.
add these comments
# wget https://github.com/magro/%{name}/archive/%{name}-%{version}.tar.gz
# tar -xf %{name}-%{version}.tar.gz
# remove non free contents
# rm -rf %{name}-%{name}-%{version}/src/test/java/de/javakaffee/kryoserializers/cglib/CustomClassLoader.java
# tar cJf %{name}-%{version}-clean.tar.xz %{name}-%{name}-%{version}
Source0:       %{name}-%{version}-clean.tar.xz

Comment 9 Timothy St. Clair 2013-10-08 19:41:56 UTC
Added a generate-tarball.sh, updated Source0, and added comments to make it clear.

Updated spec: http://tstclair.fedorapeople.org/tachyon/kryo-serializers/kryo-serializers.spec

Update srpm: http://tstclair.fedorapeople.org/tachyon/kryo-serializers/kryo-serializers-0.23-4.fc21.src.rpm

Comment 10 gil cattaneo 2013-10-08 20:49:24 UTC
Created attachment 809555 [details]
review notes

approved

Comment 11 Martin Grotzke 2013-10-09 09:08:37 UTC
I just released kryo-serializers 0.26 that includes the fix for the noncompliant license header.

FYI, kryo-serializers 0.25+ uses / depends on kryo 2.22 which provides a shaded jar as main artifact. That means that kryo-serializers should no longer need the following build deps:
BuildRequires: mvn(asm:asm)
BuildRequires: mvn(com.esotericsoftware.minlog:minlog)
BuildRequires: mvn(com.esotericsoftware.reflectasm:reflectasm)
BuildRequires: mvn(org.objenesis:objenesis)

Btw, why are these BuildRequires specified explicitely in the kryo-serializers.spec? Shouldn't they be pulled in by the BuildRequires on kryo automatically?

Comment 12 gil cattaneo 2013-10-09 09:44:12 UTC
(In reply to Martin Grotzke from comment #11)
> I just released kryo-serializers 0.26 that includes the fix for the
> noncompliant license header.
> 
> FYI, kryo-serializers 0.25+ uses / depends on kryo 2.22 which provides a
> shaded jar as main artifact. That means that kryo-serializers should no
> longer need the following build deps:
> BuildRequires: mvn(asm:asm)
> BuildRequires: mvn(com.esotericsoftware.minlog:minlog)
> BuildRequires: mvn(com.esotericsoftware.reflectasm:reflectasm)
> BuildRequires: mvn(org.objenesis:objenesis)
> 
> Btw, why are these BuildRequires specified explicitely in the
> kryo-serializers.spec? Shouldn't they be pulled in by the BuildRequires on
> kryo automatically?
these apis should be copy in kryo JAR
plugin>
                                <groupId>org.apache.maven.plugins</groupId>
                                <artifactId>maven-shade-plugin</artifactId>
                                <version>1.7</version>
                                <configuration>
                                        <shadedArtifactAttached>true</shadedArtifactAttached>
                                        <shadedClassifierName>shaded</shadedClassifierName>
                                        <artifactSet>
                                                <includes>
                                                        <include>com.esotericsoftware.reflectasm:reflectasm:shaded</include>
                                                        <include>com.esotericsoftware.minlog:minlog</include>
                                                        <include>org.objenesis:objenesis</include>
                                                </includes>
                                        </artifactSet>
                                        <relocations>
                                                <relocation>
                                                        <pattern>org.objenesis</pattern>
                                                        <shadedPattern>com.esotericsoftware.shaded.org.objenesis</shadedPattern>
                                                </relocation>
                                        </relocations>
                                </configuration>
                                <executions>
                                        <execution>
                                                <phase>package</phase>
                                                <goals>
                                                        <goal>shade</goal>
                                                </goals>
                                        </execution>
                                </executions>
                        </plugin>
but is not possible to do this for us [1]

1. https://fedoraproject.org/wiki/Packaging:No_Bundled_Libraries

Comment 13 gil cattaneo 2013-10-09 10:08:14 UTC
@ Timothy, please, update to 2.26

Comment 14 Timothy St. Clair 2013-10-09 20:13:41 UTC
Removed Spec modifications listed from previous comments and updated to 0.26 

spec: http://tstclair.fedorapeople.org/tachyon/kryo-serializers/kryo-serializers.spec

srpm: http://tstclair.fedorapeople.org/tachyon/kryo-serializers/kryo-serializers-0.26-1.fc21.src.rpm

Comment 15 gil cattaneo 2013-10-09 21:53:15 UTC
Created attachment 810197 [details]
review notes

approved

Comment 16 Timothy St. Clair 2013-10-11 02:13:56 UTC
New Package SCM Request
=======================
Package Name: kryo-serializers
Short Description: Additional kryo for standard JDK types
Owners: tstclair
Branches: f20, rawhide
InitialCC: java-sig

Comment 17 Gwyn Ciesla 2013-10-11 12:15:34 UTC
Git done (by process-git-requests).

Don't request rawhide/devel, it's automatic.


Note You need to log in before you can comment on or make changes to this bug.